//Exemple dapplication C# copiant un fichier
//Copyright (c)2001, Bischof Systems, Inc.
using System;
using System.IO;
namespace C_ExceptionHandling
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			bool copieTermine = true;
			string NomSource="", NomDestination="";
			do
			{
				try
				{
					//Remplacer la valeur en cas dchec prcdent
					copieTermine = true;
					//Lire les noms de fichiers et copier
					Console.WriteLine("Nom du fichier source : ");
					NomSource = Console.ReadLine();
					Console.WriteLine("Nom du fichier de destination : ");
					NomDestination = Console.ReadLine();
					CopierFichier(NomSource, NomDestination);
				}
				catch (FileNotFoundException)
				{
					Console.WriteLine("Fichier source inexistant : " +
						NomSource);
					//Inviter lutilisateur  ressaisir le nom du fichier
					copieTermine = false;
				}
				catch (InvalidHeaderException e)
				{
					Console.WriteLine(e.Message);
				}
				catch (Exception e)
				{
					Console.WriteLine("Erreur inattendue : " + e.Message);
				}
			} while (!copieTermine);
			Console.WriteLine("Copie du fichier termine");
			Console.ReadLine();
		}
		//Copier un fichier vers un autre fichier
		static void CopierFichier(string NomSource, string NomDestination)
		{
			StreamReader fichierSource = null;
			StreamWriter fichierDestination = null;
			FileStream fluxFichierDestination;
			bool fichierDestinationPrt = false;
			int compteurLigne;
			string texteFichier;
			//Aucun contrle derreur ici car la procdure appelante
			//est conue pour grer lerreur "Fichier inexistant".
			//NomSource doit tre converti en string afin de ne pas
			//tre interprt par le compilateur comme un type Stream.
			fichierSource = new StreamReader(NomSource.ToString());
			// ce stade tout ce qui se produit concerne les fichiers ouverts.
			//Encapsuler le code dans un bloc try pour fermer les fichiers.
			try
			{
				do
				{
					try
					{
						//Ouvrir le fichier de destination pour la sortie
						fluxFichierDestination = new FileStream(NomDestination,
							FileMode.CreateNew, FileAccess.Write);
						fichierDestination = new
							StreamWriter(fluxFichierDestination);
						//Louverture sest droule avec succs.
						fichierDestinationPrt = true;
					}
					catch (IOException)
					{
						//Nous supprimons le fichier puisquil existe dj
						File.Delete(NomDestination);
					}
				} while (!fichierDestinationPrt);
				//Les deux fichiers tant ouverts, la copie peut avoir lieu.
				compteurLigne = int.Parse(fichierSource.ReadLine());
				fichierDestination.WriteLine(compteurLigne);
				for (int ligneCourante = 1; ligneCourante <= compteurLigne;
					ligneCourante++)
				{
					texteFichier = fichierSource.ReadLine();
					if (texteFichier == null)
					{
						throw new InvalidHeaderException();
					}
					fichierDestination.WriteLine(texteFichier);
				}
			}
				//En labsence de bloc catch, toutes les erreurs non traites sont
				//renvoyes  la procdure appelante.
			finally
			{
				//Fermer tous les fichiers ouverts.
				if (fichierSource != null)
				{
					fichierSource.Close();
				}
				if (fichierDestination != null)
				{
					fichierDestination.Close();
				}
			}
		}
	}
	//Classe dexceptions personnalises pour grer un en-tte invalide.
	public class InvalidHeaderException : ApplicationException
	{
		public InvalidHeaderException()
			: this("")
		{}
		public InvalidHeaderException(string message)
			: base("En-tte du fichier source non valide." + message)
		{}
	}
}
