'Exemple dapplication Visual Basic .NET copiant un fichier 
'Copyright (c)2001, Bischof Systems, Inc.
Imports System.IO
Module Module1
    Sub Main()
        Dim copieTermine As Boolean = True
        Dim nomSource, nomDestination As String
        Do
            Try
                'Remplacer la valeur en cas dchec prcdent
                copieTermine = True
                'Lire les noms de fichiers et copier
                Console.WriteLine("Nom du fichier source : ")
                nomSource = Console.ReadLine()
                Console.WriteLine("Nom du fichier de destination : ")
                nomDestination = Console.ReadLine()
                CopierFichier(nomSource, nomDestination)
            Catch e As FileNotFoundException
                Console.WriteLine("Fichier source inexistant : " + _
                nomSource)
                'Inviter lutilisateur  ressaisir le nom du fichier
                copieTermine = False
            Catch e As InvalidHeaderException
                Console.WriteLine(e.Message)
            Catch e As Exception
                Console.WriteLine("Erreur inattendue : " + e.Message)
            End Try
        Loop While (Not copieTermine)
        Console.WriteLine("Copie du fichier termine")
        Console.ReadLine()
    End Sub
    'Copie dun fichier vers lautre fichier
    Private Sub CopierFichier(ByVal NomSource As String, ByVal NomDestination _
    As String)
        Dim fichierSource As StreamReader = Nothing
        Dim fichierDestination As StreamWriter = Nothing
        Dim fluxFichierDestination As FileStream
        Dim fichierDestinationPrt As Boolean
        Dim compteurLigne As Integer
        Dim texteFichier As String
        Dim ligneCourante As Integer
        'Aucun contrle derreur ici car la procdure appelante
        'est conue pour grer lerreur "Fichier inexistant".
        'nomSource doit tre converti en type string afin que le compilateur
        'ne linterprte pas comme un type Stream.
        fichierSource = New StreamReader(NomSource.ToString())
        ' ce stade tout ce qui se produit concerne les fichiers ouverts.
        'Encapsuler le code dans un bloc try pour fermer les fichiers lorsque le 
        'travail est termin.
        Try
            Do
                Try
                    'Ouvrir le fichier de destination pour la sortie
                    fluxFichierDestination = New FileStream(NomDestination, _
                    FileMode.CreateNew, FileAccess.Write)
                    fichierDestination = New StreamWriter(fluxFichierDestination)
                    'Louverture sest droule avec succs
                    fichierDestinationPrt = True
                Catch
                    'Nous supprimons le fichier car il existe dj
                    File.Delete(NomDestination)
                End Try
            Loop While (Not fichierDestinationPrt)
            'Les deux fichiers tant ouverts, la copie peut avoir lieu
            compteurLigne = Integer.Parse(fichierSource.ReadLine())
            fichierDestination.WriteLine(compteurLigne)
            For ligneCourante = 1 To compteurLigne
                texteFichier = fichierSource.ReadLine()
                If (texteFichier = Nothing) Then
                    Throw New InvalidHeaderException()
                End If
                fichierDestination.WriteLine(texteFichier)
            Next
            'En labsence de bloc catch, toutes les erreurs non traites sont
            'renvoyes  la procdure appelante
        Finally
            'Fermer tous les fichiers
            If (Not fichierSource Is Nothing) Then
                fichierSource.Close()
            End If
            If (Not fichierDestination Is Nothing) Then
                fichierDestination.Close()
            End If
        End Try
    End Sub
    'Classe dexceptions personnalises pour grer un en-tte non valide
    Public Class InvalidHeaderException
        Inherits ApplicationException
        Public Sub New()
            Me.New("")
        End Sub
        Public Sub New(ByVal message As String)
            MyBase.New("En-tte du fichier source non valide." + message)
        End Sub
    End Class
End Module

