//criture dans un fichier journal en C#
//Copyright (c)2001, Bischof Systems, Inc.

using System;

namespace C_Classes
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			ExcuterCompteCourant();
			Console.ReadLine();
		}
		static void ExcuterCompteCourant()
		{
			CCompteCourant CompteCourant = new CCompteCourant();

			CompteCourant.Dposer(500);
			CompteCourant.crireCompte(400);
			CompteCourant.crireCompte(75);                
			CompteCourant.crireCompte(50);                
			CompteCourant.Dispose();
			CompteCourant = null;
		}


		public class CCompteCourant
		{
			static double SoldeMinimal = 100;
			private double SoldeCourant;
			private System.IO.StreamWriter FichierJournal;
			//Ouverture du fichier de sortie par le constructeur
			public CCompteCourant()
			{
				FichierJournal = new System.IO.StreamWriter(@"C:\FichierJournal.txt");
			}
			//Dpt dargent sur le compte courant
			public void Dposer(double Montant)
			{
				SoldeCourant += Montant;
				FichierJournal.WriteLine("Dpt : {0}; Nouveau solde : {1}", 
					Montant, SoldeCourant);
			}
			//Retrait dargent sur le compte courant
			public void crireCompte(double Montant)
			{
				//Vrifier que le montant nest pas infrieur  0
				if ((SoldeCourant - Montant) > 0)
				{
					SoldeCourant -= Montant;
					//Enregistrer lexcution de la transaction
					FichierJournal.WriteLine("Retrait : {0}; Nouveau solde : {1}",
						Montant, SoldeCourant);        
					if (SoldeCourant < SoldeMinimal) 
					{
						//Enregistrer le dpassement du solde minimal
						FichierJournal.WriteLine("Vous tes en dessous du solde " + 
							"minimal de {0}", SoldeMinimal);
					}
				}
				else
				{
					//Enregistrer linsuffisance de fonds
					FichierJournal.WriteLine("Fonds insuffisants - {0} nont pas t " +
						"retirs", Montant);
				}
			}

			public void Dispose()
			{
				FichierJournal.Close();
				GC.SuppressFinalize(this);
			}
			~CCompteCourant()
			{
				FichierJournal.Close();
			}
		}        
	}
}
