//Calcul du prix de vente en C#
//Copyright (c)2001, Bischof Systems, Inc.

using System;

namespace C_Inheritance
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)

		{
			Article Magazine = new Article("Magazine");
			Livre Bestseller = new Livre();
			PrintInfo(Magazine, 10);
			PrintInfo(Bestseller, 5, 15);
			Console.ReadLine(); 
		}
		static void PrintInfo(Article Produit, double Prix)
		{
			Console.WriteLine("Prix de 1 {0} : {1}", Produit.Description, 
				Produit.PrixTotal(Prix));
		}
		static void PrintInfo(Article Produit, int Qt, double Prix)
		{
			Console.WriteLine("Prix de {0} {1}S : {2}", Qt, 
				Produit.Description, Produit.PrixTotal(Qt, Prix));
		}
	}

	public class Article
	{
		public string Description;
		//Code du constructeur - Imposer le nom en majuscules
		public Article():
			this("")
		{}
		public Article(string Description)
		{
			this.Description = Description.ToUpper();
		}
		// Calculer le prix total de tous les articles - Qt facultative
		public virtual double PrixTotal(double Prix)
		{
			return this.PrixTotal(1, Prix);
		}
		public virtual double PrixTotal(int Qt, double Prix) 
		{
			return Qt * Prix;
		}
	}
    

	//Classe calculant le prix des livres
	public class Livre: Article
	{
		//Code du constructeur
		public Livre():
			this("Livre")
		{} //En labsence de description, utiliser "Livre" par dfaut
		public Livre(string Description):
			base(Description)
		{}
		//Livres vendus avec une remise de 25 %
		public override double PrixTotal(int Qt ,double Prix)
		{
			double Total;
			Total = base.PrixTotal(Qt, Prix);
			Total *= 0.75;
			return Total;
		}
	}
}
