//Gestion dun compte courant en C#
//Copyright (c)2001, Bischof Systems, Inc.

using System;

namespace C_Events
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			//Crer linstance dobjet
			//Dfinir la rfrence dvnement pour la mthode AlerteTransaction()
			CCompteCourant CompteCourant = new CCompteCourant(100);
			CompteCourant.MessageTransaction += 
				new CCompteCourant.GestionnaireMessageCompte(AlerteTransaction);

			//Effectuer les transactions sur le compte
			CompteCourant.Dpt(500);
			CompteCourant.Retrait(400);
			CompteCourant.Retrait(75);                
			CompteCourant.Retrait(50);                
			Console.ReadLine();
		}

		static void AlerteTransaction(object sender, string Message)
		{
			Console.WriteLine(Message);
		}
        
		public class CCompteCourant
		{
			public delegate void GestionnaireMessageCompte(object sender, 
				string message);
			public event GestionnaireMessageCompte MessageTransaction;
			private double SoldeCourant;
			private double SoldeMinimal;

			public CCompteCourant(double SoldeMinimal)
			{
				this.SoldeMinimal = SoldeMinimal;
			}
			public double Solde
			{
				get
				{
					return SoldeCourant;
				}
			}            
			//Dpt dargent sur le compte courant
			public void Dpt(double Montant)
			{
				SoldeCourant += Montant;
				//Informer lutilisateur du dpt
				MessageTransaction(this, String.Format("Dpt : {0}; " +
					"Nouveau solde : {1}", Montant, SoldeCourant));
			}
			//Retrait dargent du compte courant

			public void Retrait(double Montant)
			{
				//Vrifier que le solde nest pas infrieur  0
				if ((SoldeCourant - Montant) > 0) 
				{
					SoldeCourant -= Montant;
					//Informer lutilisateur de la transaction
					Console.WriteLine("Retrait : {0}; Nouveau solde : {1}",
						Montant, SoldeCourant);           
					//Vrifier si le solde minimal a t atteint
					if (SoldeCourant < SoldeMinimal)
					{
						//Dclencher lvnement sur le dpassement du solde minimal
						MessageTransaction(this, "Attention ! Vous tes sous le " + 
							"solde minimal de " + SoldeMinimal + ".");
					}
				}
				else
				{
					// Dclencher lvnement sur linsuffisance de fonds
					MessageTransaction(this, "Attention ! Fonds insuffisants : " + Montant +
						" euros nont pas t retirs.");
				}
			}
		}            
	}
}
