//Affichage et mise  jour de la base de donnes Comptoir en C#
//Copyright (c)2001 by Bischof Systems, Inc.

using System;
using System.Data;  //requis pour la classe DataSet
using System.Data.SqlClient;

namespace C_ADO
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			//Dclarez les objets Sql
			SqlConnection dbCn = new SqlConnection();
			SqlCommand dbCmd = null;
			SqlDataAdapter dbDa = null;
			SqlCommandBuilder dbBldr = null;
			SqlDataReader dbDr = null;
			//Dclarez les objets Data
			DataSet ds = null;
			DataTable dt = null;
			DataRow dr = null;
			//Dclarez les variables dentre utilisateur
			int slection = 0; int CompteurLigne = 0;
			string entre = "";
			//Ouvrir la connexion de base de donnes
			dbCn.ConnectionString = "Server=(local);Uid=sa;Database=Comptoir";
			dbCn.Open();
			//Prparer linstruction SQL
			dbCmd = new SqlCommand("Select * From Messagers", dbCn);
			dbCmd.CommandType = CommandType.Text;
			//Lire la table dans le DataSet avec le DataAdapter
			ds = new DataSet();
			dbDa = new SqlDataAdapter();
			dbDa.SelectCommand = dbCmd;
			dbDa.Fill(ds,"Messagers");
			dbBldr = new SqlCommandBuilder(dbDa);
			//Dfinir une rfrence  la table
			dt = ds.Tables["Messagers"];

			//Ne pas conserver la connexion ouverte au-del du temps ncessaire
			dbCn.Close();  
			Console.WriteLine("ADO .NET");
			do
			{   
				Console.WriteLine("\n1. Afficher la table en mmoire");
				Console.WriteLine("2. Afficher la table physique");
				Console.WriteLine("3. Modifier un enregistrement");
				Console.WriteLine("4. Ajouter un enregistrement");
				Console.WriteLine("5. Supprimer un enregistrement");
				Console.WriteLine("6. Valider les modifications dans la base de donnes");
				Console.Write("Votre choix : ");
				slection = int.Parse('0'+Console.ReadLine());
				switch (slection)
				{
					case 1:     //Afficher la table charge en mmoire
						Console.WriteLine();
						for (CompteurLigne=0;CompteurLigne < dt.Rows.Count; CompteurLigne++)
						{
							dr = dt.Rows[CompteurLigne];
							if (dr.RowState != DataRowState.Deleted)
							{
								Console.WriteLine("Ligne #{0}: {1} {2} {3}", 
									CompteurLigne + 1, dr[0], 
									dr[1].ToString().PadRight(30), dr[2]);
							}
						}
						break;
					case 2:     //Afficher la table physique
						Console.WriteLine();
						CompteurLigne=1;
						dbCn.Open();
						dbDr = dbCmd.ExecuteReader();
						while (dbDr.Read())
						{
							Console.WriteLine("Ligne #{0}: {1} {2} {3}",CompteurLigne, 
								dbDr.GetInt32(0), dbDr.GetString(1).PadRight(30),
								dbDr.GetString(2));
						}
						dbDr.Close();
						dbCn.Close();
						break;

					case 3:     //Modifier une ligne en fonction de la cl primaire
						Console.Write("Quel Numro  ?");
						entre = Console.ReadLine();
						//Dfinir le filtre pour obtenir la ligne slectionne
						dr = dt.Select("[N messager] = "+entre)[0];
						//Rcuprer les modifications de lutilisateur
						Console.Write("En cours : {0} Nouveau : ", 
							dr["Socit"]);
						entre = Console.ReadLine();
						if (entre!= "")
						{
							dr["Socit"] = entre;
						}
						Console.Write("En cours : {0} Nouveau : ", dr["Tlphone"]);
						entre = Console.ReadLine();
						if (entre!= "")
						{
							dr["Tlphone"] = entre;
						}
						break;
					case 4:     //Ajouter une nouvelle ligne
						//Crer lobjet ligne (row) et le remplir
						dr = dt.NewRow();
						Console.Write("Entreprise : ");
						entre = Console.ReadLine();
						dr["Socit"] = entre;
						Console.Write("Tlphone : ");
						entre = Console.ReadLine();
						dr["Tlphone"] = entre;
						//Ajouter lobjet row  la collection
						dt.Rows.Add(dr);
						break;         
					case 5:     //Supprimer une ligne  laide de lindex
						Console.Write("Numro de ligne : ");
						entre = Console.ReadLine();
						//Supprimer lenregistrement 
						dt.Rows[int.Parse(entre)-1].Delete();
						break;

					case 6:     //Valider les modifications dans la base de donnes
						//SQLCommandBuilder valide les modifications pour vous
						dbDa.Update(ds, "Messagers");
						dt.AcceptChanges();
						//Effacer la table courante et lactualiser
						dt.Reset();
						dbDa.Fill(ds, "Messagers");
						break;
				}               
			} while (slection!=0);
		}
	}
}
