//Classe RegEditor en C#
//Copyright (c)2001, Bischof Systems, Inc.

using System;
using Microsoft.Win32;

namespace C_Registry
{

	class Class1
	{
		static void Main(string[] args)
		{
			RegEditor editeurReg;    
			string nomCl = "Best Sellers";
			string donnesCl = " Langages .NET : guide des quivalences";
			string donnesNouvelles;
			//Indiquer  lutilisateur la cl qui va tre crite
			Console.WriteLine("criture dans la base de registre");
			Console.WriteLine("Nom de la cl : {0}", nomCl);
			Console.WriteLine("Valeur de la cl : {0}", donnesCl);
			//Instancier lditeur personnalis de la base de registre 
			editeurReg = new RegEditor(@"SOFTWARE/Eyrolles");
			//crire la chane dans la cl de la base de registre
			editeurReg.SetValue(nomCl, donnesCl);
			//Lecture dans une nouvelle variable pour sassurer quelle a fonctionn
			donnesNouvelles = editeurReg.GetValue(nomCl);
			Console.WriteLine("Lecture depuis la base de registre");
			Console.WriteLine("Valeur de la cl : {0}", donnesNouvelles);
			//Supprimer la cl aprs avoir termin
			Console.WriteLine("Suppression en cours...");
			editeurReg.DeleteValue(nomCl);
			donnesNouvelles = editeurReg.GetValue(nomCl);
			Console.WriteLine("Valeur de la cl : {0}", donnesNouvelles);
			Console.WriteLine("Termin");
			Console.ReadLine();
		}
	}

	//Les cls seront crites par la classe selon le chemin spcifi.
	//Classe conue pour utiliser la cl HKey_Local_Machine
	class RegEditor
	{
		private RegistryKey clRegistre;
		//Chemin daccs de la base de registre requis par le constructeur
		public RegEditor(string RegPath)
		{
			clRegistre = GetRegistryKey(RegPath);
		}

		//crire une valeur dans la base de registre
		public void SetValue(string KeyName, object KeyValue)
		{
			clRegistre.SetValue(KeyName, KeyValue);
		}
		//Lire une valeur dans la base de registre, renvoyer une chane pour 
		//des raisons de simplicit, 
		public string GetValue(string KeyName)
		{
			return (string)clRegistre.GetValue(KeyName);
		}
		//Supprimer la valeur de la cl
		public void DeleteValue(string KeyName)
		{
			clRegistre.DeleteValue(KeyName);
		}
		//Prendre un chemin de cl de base de registre et rcuprer la cl 
		//qui lui est associe
		private RegistryKey GetRegistryKey(string RegPath)
		{
			RegistryKey clRegistre;
			string[] pathMembers = RegPath.Split('/');
			//Ici, le chemin racine est HKEY_LOCAL_MACHINE. Une modification
			//judicieuse consisterait  utiliser un paramtre 
			//indiquant le chemin daccs racine.
			clRegistre = Registry.LocalMachine;
			//Parcourir la base de registre jusqu obtenir la bonne cl
			for (int currentMember=0; currentMember<pathMembers.Length;
				currentMember++)
			{
				//Utiliser CreateSubKey pour vrifier lexistence de la cl
				clRegistre = clRegistre.CreateSubKey(pathMembers[currentMember]);
			}   
			return clRegistre;
		}
	}
}
